//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.ComponentModel;

namespace LicenseTimeBombClass
{
	/// <summary>
	/// Summary description for UserClass.
	/// </summary>
	[LicenseProvider(typeof(TimeBombLicenseProvider))]
	public class UserClass
	{
		private License license = null;
		public UserClass()
		{
			// Add Validate to the control's constructor.
			license = (TimeBombLicenseProvider.TimeBombLicense)LicenseManager.Validate(typeof(UserClass), this);
		}
		public void Dispose( )
		{
			if (license != null) 
			{
				license.Dispose();
				license = null;
			}
		}
	}
}
