//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace LicensedControl
{
	/// <summary>
	/// Summary description for UserControl.
	/// </summary>
	[LicenseProvider(typeof(LicFileLicenseProvider))]
	public class UserControl : System.Windows.Forms.UserControl
	{
		private License license = null;
		private System.Windows.Forms.Label label;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControl()
		{
			// Add Validate to the control's constructor.
			license = LicenseManager.Validate(typeof(UserControl), this);

			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitForm call

		}

		public new string Text
		{
			get
			{
				return label.Text;
			}
			set
			{
				label.Text = value;
			}
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
				if (license != null) 
				{
					license.Dispose();
					license = null;
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// label
			// 
			this.label.Location = new System.Drawing.Point(16, 16);
			this.label.Name = "label";
			this.label.Size = new System.Drawing.Size(200, 16);
			this.label.TabIndex = 0;
			this.label.Text = "Custom Control";
			this.label.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// UserControl
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label});
			this.Name = "UserControl";
			this.Size = new System.Drawing.Size(232, 48);
			this.ResumeLayout(false);

		}
		#endregion
	}
}
