//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Text.RegularExpressions;

namespace Samples {
    public class RegExMatcherMulti {
        public static void Main(String[] args){
            Regex digitregex = new Regex("(?<number>\\d+)");
            String s = "abc 123 def 456 ghi 789";

            if ( args.Length > 0 ) {
                s = String.Join(" ", args);
            }

            MatchCollection mc = digitregex.Matches(s);

            if ( mc.Count > 0 ) {
                System.Console.WriteLine("Digits:");
                foreach (Match m in mc) {
                    System.Console.WriteLine("  " + m.Value);
                }
            } else {
                System.Console.WriteLine("[" + s + "] contains no numbers.");
            }

            System.Console.WriteLine();
            System.Console.WriteLine("Press Enter to Continue...");
            System.Console.ReadLine();
        }
    }
}