//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Diagnostics;

namespace WebProcessViewer
{
	/// <summary>
	/// Summary description for WebProcessForm.
	/// </summary>
	public class WebProcessForm : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Table ProcessTable;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Generate rows and cells           
			TableRow r = new TableRow();
			// Process ID
			TableCell c = new TableCell();
			c.Controls.Add(new LiteralControl("Process ID"));
			r.Cells.Add(c);
			// Process Name
			c = new TableCell();
			c.Controls.Add(new LiteralControl("Process Name"));
			r.Cells.Add(c);
			// Thread Count
			c = new TableCell();
			c.Controls.Add(new LiteralControl("Thread Count"));
			r.Cells.Add(c);
			// Working Set
			c = new TableCell();
			c.Controls.Add(new LiteralControl("Working Set"));
			r.Cells.Add(c);
			// Virtual Memory Size
			c = new TableCell();
			c.Controls.Add(new LiteralControl("Virtual Memory"));
			r.Cells.Add(c);
			// Total Processor Time
			c = new TableCell();
			c.Controls.Add(new LiteralControl("Processor Time"));
			r.Cells.Add(c);
			ProcessTable.Rows.Add(r);
			Process [] pa = Process.GetProcesses();
			foreach(Process p in pa)
			{
				ProcessThreadCollection ptc = p.Threads;
				r = new TableRow();
				// Process ID
				c = new TableCell();
				c.HorizontalAlign = HorizontalAlign.Right;
				c.Controls.Add(new LiteralControl(p.Id.ToString()));
				r.Cells.Add(c);
				// Process Name
				c = new TableCell();
				c.HorizontalAlign = HorizontalAlign.Right;
				c.Controls.Add(new LiteralControl(p.ProcessName));
				r.Cells.Add(c);
				// Thread Count
				c = new TableCell();
				c.HorizontalAlign = HorizontalAlign.Right;
				c.Controls.Add(new LiteralControl(ptc.Count.ToString("#,#")));
				r.Cells.Add(c);
				// Working Set
				c = new TableCell();
				c.HorizontalAlign = HorizontalAlign.Right;
				c.Controls.Add(new LiteralControl(p.WorkingSet.ToString("#,#")));
				r.Cells.Add(c);
				// Virtual Memory Size
				c = new TableCell();
				c.HorizontalAlign = HorizontalAlign.Right;
				c.Controls.Add(new LiteralControl(p.VirtualMemorySize.ToString("#,#")));
				r.Cells.Add(c);
				// Total Processor Time
				c = new TableCell();
				c.HorizontalAlign = HorizontalAlign.Right;
				c.Controls.Add(new LiteralControl(p.TotalProcessorTime.ToString()));
				r.Cells.Add(c);

				ProcessTable.Rows.Add(r);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
