//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Collections;

namespace FrameworkLibraries
{
	public class ArrayListMain 
	{
		static void Main(string [] args)
		{
			ArrayList al = new ArrayList();
			lock(al.SyncRoot)
			{
				al.Add("This");
				al.Add("is");
				al.Add("a");
				al.Add("test");
				al.Add(0);
				al.Add(1);
				Console.WriteLine("Sychronized: {0}", al.IsSynchronized);
				Console.WriteLine("Read-only: {0}", al.IsReadOnly);
				Console.WriteLine("Fixed size: {0}", al.IsFixedSize);
				Console.WriteLine("Capacity: {0}", al.Capacity);
				Console.WriteLine("Count: {0}", al.Count);
			}
			foreach(object o in al)
			{
				Console.WriteLine("{0} {1}", o, o.GetType());
			}
			al = ArrayList.Synchronized(al);
			Console.WriteLine("Sychronized: {0}", al.IsSynchronized);
		}
	}
}