//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Collections.Specialized;

namespace FrameworkLibraries
{
	public class BitVector32Main 
	{
		// Create masks for the bit vector.
		private static readonly int MaskOne = BitVector32.CreateMask();
		private static readonly int MaskTwo = BitVector32.CreateMask(MaskOne);
		private static readonly int MaskThree = BitVector32.CreateMask(MaskTwo);
		private static readonly int MaskFour = BitVector32.CreateMask(MaskThree);
		private static readonly int MaskFive = BitVector32.CreateMask(MaskFour);
		private static readonly int MaskSix = BitVector32.CreateMask(MaskFive);
		private static readonly int MaskSeven = BitVector32.CreateMask(MaskSix);
		private static readonly int MaskEight = BitVector32.CreateMask(MaskSeven);
		// Create sections for the bit vector.
		private static readonly BitVector32.Section first = 
			BitVector32.CreateSection(15);
		private static readonly BitVector32.Section second = 
			BitVector32.CreateSection(15, first);
 
		static void Main(string [] args)
		{
			BitVector32 bv = new BitVector32();
			bv[MaskEight] = true;
			bv[MaskOne] = true;
			Console.WriteLine("{0}", bv);
			bv = new BitVector32();
			bv[first] = 14;
			bv[second] = 7;
			Console.WriteLine("{0}", bv);
		}
	}
}