//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.ComponentModel;
using System.Globalization;

namespace FrameworkLibraries
{
	public class Complex
	{
		private double re;
		private double im;
		public Complex(double re, double im)
		{
			this.re = re;
			this.im = im;
		}
		public double Real
		{
			get
			{
				return re;
			}
			set
			{
				re = value;
			}
		}
		public double Imaginary
		{
			get
			{
				return im;
			}
			set
			{
				im = value;
			}
		}
		public override string ToString()
		{
			return string.Format("{0},{1}", re, im);
		}
		public string ToString(string format)
		{
			if (format.Equals ("p"))
			{
				return string.Format("{0},{1}",
					                 Math.Sqrt(re*re + im*im),
					                 Math.Atan2(im,re));
			}
			else
			{
				return ToString();
			}
		}
	}
	public class CustomFormatMain 
	{
		static void Main(string [] args)
		{
			Complex c = new Complex(3,4);
			Console.WriteLine("{0} -> {1}", c, c.ToString("p"));
		}
	}
}