//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

namespace FrameworkLibraries
{
	public class DateTimeMain 
	{
		static void Main(string [] args)
		{
			Console.WriteLine("Min: {0}", DateTime.MinValue);
			Console.WriteLine("Max: {0}", DateTime.MaxValue);
			DateTime date = DateTime.Now;
			Console.WriteLine("Long DateTime {0} {1}",
				              date.ToLongDateString(),
				              date.ToLongTimeString());
			Console.WriteLine("Date: {0}", date.Date);
			Console.WriteLine("Month: {0}", date.Month);
			Console.WriteLine("Day: {0}", date.Day);
			Console.WriteLine("Day of week: {0}", date.DayOfWeek);
			Console.WriteLine("Day of year: {0}", date.DayOfYear);
			Console.WriteLine("TimeOfDay: {0}", date.TimeOfDay);
			Console.WriteLine("Hour: {0}", date.Hour);
			Console.WriteLine("Minute: {0}", date.Minute);
			Console.WriteLine("Second: {0}", date.Second);
			Console.WriteLine("Millisecond: {0}", date.Millisecond);
			Console.WriteLine("Ticks: {0}", date.Ticks);
			Console.WriteLine("In one hour it will be: {0} {1}",
				              date.AddHours(1).ToLongDateString(),
				              date.AddHours(1).ToLongTimeString());
			Console.WriteLine("An hour ago it was: {0} {1}",
				              date.AddHours(-1).ToLongDateString(),
				              date.AddHours(-1).ToLongTimeString());
			Console.WriteLine("Tomorrow will be: {0} {1}",
				              date.AddDays(1).ToLongDateString(),
				              date.AddDays(1).ToLongTimeString());
			Console.WriteLine("Yesterday was be: {0} {1}",
				              date.AddDays(-1).ToLongDateString(),
				              date.AddDays(-1).ToLongTimeString());
			Console.WriteLine("Next week will be: {0} {1}",
				              date.AddDays(7).ToLongDateString(),
				              date.AddDays(7).ToLongTimeString());
			Console.WriteLine("Last week was be: {0} {1}",
				              date.AddDays(-7).ToLongDateString(),
				              date.AddDays(-7).ToLongTimeString());
			Console.WriteLine("Next month will be: {0} {1}",
				              date.AddMonths(1).ToLongDateString(),
				              date.AddMonths(1).ToLongTimeString());
			Console.WriteLine("Last month was be: {0} {1}",
				              date.AddMonths(-1).ToLongDateString(),
				              date.AddMonths(-1).ToLongTimeString());
		}
	}
}