//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Messaging;

namespace FrameworkLibraries
{
	public class MessageQueueReceive 
	{

		static void Main(string [] args)
		{
			// Create a new instance of the class.
			MessageQueueReceive q = new MessageQueueReceive();
			// Receive a message from a queue.
			q.ReceiveMessage();
			return;
		}

		//**************************************************
		// Receives a message containing an Order.
		//**************************************************
		public void ReceiveMessage()
		{
			// Connect to the a queue on the local computer.
			MessageQueue myQueue = new MessageQueue(".\\myQueue");

			// Set the formatter to indicate the body contains an Order.
			myQueue.Formatter = new XmlMessageFormatter(new string[]{"System.String"});
         
			try
			{
				// Receive and format the message. 
				// Wait 5 seconds for a message to arrive.
				Message myMessage =   myQueue.Receive(new TimeSpan(0,0,5)); 
				string messageText = (string)myMessage.Body;
				// Display message information.
				Console.WriteLine("Message received: " + messageText);
			}
			catch (MessageQueueException e)
			{
				// Handle no message arriving in the queue.
				if (e.MessageQueueErrorCode == MessageQueueErrorCode.IOTimeout)
				{
					Console.WriteLine("No message arrived in the queue.");
				}         

				// Handle other sources of a MessageQueueException.
			}
         
			// Handle invalid serialization format.
			catch (InvalidOperationException e)
			{
				Console.WriteLine(e.Message);
			}
         
			// Catch other exceptions as necessary.

			return;
		}
	}
}