//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Messaging;

namespace FrameworkLibraries
{
	public class MessageQueueSend 
	{
		static void Main(string [] args)
		{
			string message = "Hello!!!";
			if(args.Length > 0)
				message = args[0];
			// Create a new instance of the class.
			MessageQueueSend myNewQueue = new MessageQueueSend();
			// Send a message to a queue.
			myNewQueue.SendMessage(message);
			return;
		}
		//**************************************************
		// Sends a message to a queue.
		//**************************************************
  		public void SendMessage(string message)
		{
			string queueName = ".\\myQueue";
			if(MessageQueue.Exists(queueName))
			{
				// Connect to a queue on the local computer.
				MessageQueue myQueue = new MessageQueue(queueName);
				// Set the formatter to indicate the body contains an Order.
				myQueue.Formatter = new XmlMessageFormatter(new string[]{"System.String"});
				// Send a message to the queue.
				if (myQueue.Transactional == true)
				{
					Console.WriteLine("Sending transactional message");
					myQueue.Send(message, new MessageQueueTransaction());
				}
				else
				{
					Console.WriteLine("Sending message");
					myQueue.Send(message);
				}
			}
			else
			{
				Console.WriteLine("{0} does not exists.", queueName);
				MessageQueue [] mqa = MessageQueue.GetPublicQueues();
				foreach(MessageQueue m in mqa)
				{
					Console.WriteLine("Public: {0}", m.QueueName);
				}
				mqa = MessageQueue.GetPrivateQueuesByMachine(".");
				foreach(MessageQueue m in mqa)
				{
					Console.WriteLine("Private: {0}", m.QueueName);
				}
			}
			return;
		}
	}
}