//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Collections;

namespace FrameworkLibraries
{
	public class QueueMain 
	{
		static void Main(string [] args)
		{
			Queue q = new Queue();
			lock(q.SyncRoot)
			{
				q.Enqueue("First");
				q.Enqueue("Second");
				q.Enqueue("Third");
				q.Enqueue("Fourth");
				q.Enqueue("Fifth");
			}
			Console.WriteLine("Count: {0}", q.Count);
			lock(q.SyncRoot)
			{
				foreach(object o in q)
				{
					Console.WriteLine("{0} {1}", o, o.GetType());
				}
				object obj;
				obj = q.Dequeue();
				Console.WriteLine("{0} {1}", q.Count, obj);
				obj = q.Dequeue();
				Console.WriteLine("{0} {1}", q.Count, obj);
				obj = q.Dequeue();
				Console.WriteLine("{0} {1}", q.Count, obj);
				obj = q.Dequeue();
				Console.WriteLine("{0} {1}", q.Count, obj);
				obj = q.Dequeue();
				Console.WriteLine("{0} {1}", q.Count, obj);
			}
		}
	}
}