//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Text.RegularExpressions;

namespace FrameworkLibraries
{
    public class RegexMain
	{
		public static void Main(String[] args)
		{
			Regex pathregex = new Regex(@"(?<drive>[^:]:\\)?((?<dir>[^\\]+)\\)*(?<file>((?<base>[^.]+)[.]?(?<ext>.*)))");
			string s = @"c:\a\b\c\d\e.cs";

			if ( args.Length > 0 )
			{
				s = args[0];
			}

			Match mc = pathregex.Match(s);

			if ( mc.Success )
			{
				Console.WriteLine("Success in parsing \"{0}\" !!", s);
				Console.WriteLine("Drive: " + mc.Groups["drive"].Value);
				CaptureCollection cc = mc.Groups["dir"].Captures;
				// Print number of captures in this group.
				Console.WriteLine("Directories: {0}", cc.Count);
				// Loop through each capture in group.
				for (int i = 0; i < cc.Count; i++) 
				{
					// Print capture and position.
					Console.WriteLine("{0} starts at character {1}", cc[i], cc[i].Index);
				}
				Console.WriteLine("File: " + mc.Groups["file"].Value);
				Console.WriteLine("Base: " + mc.Groups["base"].Value);
				Console.WriteLine("Extension: " + mc.Groups["ext"].Value);
			}
			else
			{
				Console.WriteLine(s + " is not a valid path address");
			}
		}
	}
}