//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Text.RegularExpressions;

namespace FrameworkLibraries
{
    public class RegexMain
	{
        public static void Main(String[] args)
		{
            Regex emailregex = new Regex("(?<user>[^@]+)@(?<host>.+)");
            string s = "first.last@mycompany.com";

            if ( args.Length > 0 )
			{
                s = args[0];
            }

            Match m = emailregex.Match(s);

            if ( m.Success )
			{
                Console.WriteLine("User: " + m.Groups["user"].Value);
                Console.WriteLine("Host: " + m.Groups["host"].Value);
            }
			else
			{
                Console.WriteLine(s + " is not a valid email address");
            }
        }
    }
}