//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Timers;

namespace FrameworkLibraries
{
	public class TimerMain 
	{
		private static long lastTickCount = 0;
		public static void OnElapsedEvent(object source, ElapsedEventArgs e)
		{
			if(lastTickCount == 0)
			{
				lastTickCount = Environment.TickCount;
				Console.WriteLine("Hello!!");
			}
			else
			{
				long currentTickCount = Environment.TickCount;
				Console.WriteLine("Hello!! {0}", currentTickCount - lastTickCount);
				lastTickCount = currentTickCount;
			}
		}
		static void Main(string [] args)
		{
			Timer timer = new Timer();
			timer.Elapsed+=new ElapsedEventHandler(OnElapsedEvent);
			// Set the Interval to 1 second.
			timer.Interval = 1000;
			timer.Enabled = true;
 
			Console.WriteLine("Press <enter> to quit the sample.");
			Console.ReadLine();
		}
	}
}
