//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Globalization;

namespace FrameworkLibraries
{
	public class TimeZoneMain 
	{
		static void Main(string [] args)
		{
			TimeZone tz = TimeZone.CurrentTimeZone;
			Console.WriteLine("{0} {1}", tz.DaylightName, tz.StandardName);
			DaylightTime dt = tz.GetDaylightChanges(DateTime.Now.Year);
			Console.WriteLine("Start daylight savings time {0}", dt.Start);
			Console.WriteLine("End daylight savings time {0}", dt.End);
			Console.WriteLine("Daylight savings time change {0}", dt.Delta);
			Console.WriteLine("Is daylight savings? {0}", tz.IsDaylightSavingTime(DateTime.Now));
			Console.WriteLine("UTC {0}", tz.ToUniversalTime(DateTime.Now));
		}
	}
}