//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Collections;
using System.Collections.Specialized;

namespace FrameworkLibraries
{
	public class CollectionsUtilMain 
	{
		static void Main(string [] args)
		{
			Hashtable ht = CollectionsUtil.CreateCaseInsensitiveHashtable();
			ht.Add("First", "This is the first one");
			ht.Add("Second", "This is the second one");
			ht.Add("Third", "This is the third one");
			ht.Add("Fourth", "This is the fourth one");
			ht.Add("Fifth", "This is the fifth one");
			foreach(DictionaryEntry de in ht)
			{
				Console.WriteLine("{0} {1}", de.Key, de.Value);
			}
			Console.WriteLine("Contains \"first\": {0}", ht.Contains("first"));
			Console.WriteLine("Contains \"sixth\": {0}", ht.Contains("sixth"));
			Console.WriteLine("ht[\"FIRST\"]: \"{0}\"", ht["FIRST"]);

			// Now a case-insensitive sorted list
			SortedList sl = CollectionsUtil.CreateCaseInsensitiveSortedList();
			sl.Add("First", "This is the first one");
			sl.Add("Second", "This is the second one");
			sl.Add("Third", "This is the third one");
			sl.Add("Fourth", "This is the fourth one");
			sl.Add("Fifth", "This is the fifth one");
			foreach(DictionaryEntry de in sl)
			{
				Console.WriteLine("\"{0}\" {1}", de.Key, de.Value);
			}
			Console.WriteLine("Contains \"first\": {0}", sl.Contains("first"));
			Console.WriteLine("Contains \"sixth\": {0}", sl.Contains("sixth"));
			Console.WriteLine("sl[\"FIRSTT\"]: \"{0}\"", sl["FIRST"]);
		}
	}
}