//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.IO;
using System.Xml;
using System.Xml.Xsl;
using System.Xml.XPath;

namespace FrameworkLibraries
{
	public class TransformXmlFile
	{
		public static void Main(string [] args)
		{
			string xmldocument = "booklist.xml";
			string xsldocument = "total-sales.xsl";
			TransformXmlFile transformXml = new TransformXmlFile();
			if ( args.Length > 1 ) 
			{
				transformXml.Process(args[0], args[1]);
			}
			else
				transformXml.Process(xmldocument, xsldocument);
		}

		public void Process(string document, string xsl)
		{
			XmlReader reader = null;
			try
			{
				XPathDocument myXPathDocument = new XPathDocument (document);
				XslTransform myXslTransform = new XslTransform();
				myXslTransform.Load(xsl);
				reader = myXslTransform.Transform(myXPathDocument, null);
				while (reader.Read())
				{
					Console.WriteLine(reader.Value);
				}
			}
			catch (Exception e)
			{
				Console.WriteLine ("Exception: {0}", e.ToString());
			}
			finally
			{
				Console.WriteLine();
				Console.WriteLine("Processing of the file {0} complete.", document);
				// Finished with XmlTextReader
				if (reader != null)
					reader.Close();
			}
		}
	}
}
